package eu.mhsl.minecraft.pixelblocks.listeners;

import eu.mhsl.minecraft.pixelblocks.PixelBlockItem;
import eu.mhsl.minecraft.pixelblocks.pixelblock.PixelBlock;
import eu.mhsl.minecraft.pixelblocks.pixelblock.PixelBlockWorld;
import eu.mhsl.minecraft.pixelblocks.utils.Direction;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.inventory.ItemStack;

public class PlacePixelBlockListener implements Listener {
    @EventHandler
    public void onBlockPlace(BlockPlaceEvent event) {
        ItemStack usedItem = event.getItemInHand();
        PixelBlockItem.BlockInfo info = PixelBlockItem.getBlockInfo(usedItem);
        if(info == null) return;

        World playerWorld = event.getPlayer().getWorld();
        if(PixelBlockWorld.isPixelWorld(playerWorld)) {
            event.getPlayer().sendMessage(Component.text("In Pixelblöcken kann kein Pixelblock platziert werden.", NamedTextColor.RED));
            event.setCancelled(true);
            return;
        }

        Location newBlockLocation = event.getBlock().getLocation();
        playerWorld.getBlockAt(newBlockLocation).setType(Material.AIR);

        Direction direction = Direction.vectorToDirection(event.getPlayer().getLocation().getDirection());

        PixelBlock.createPixelBlock(
            info.id(),
            info.hasOwner() ? info.owner() : event.getPlayer().getUniqueId(),
            newBlockLocation,
            direction
        );
//        if(!info.hasOwner()) {
//            pixelBlock = PixelBlock.createPixelBlock(
//                UUID.randomUUID(),
//                event.getPlayer().getUniqueId(),
//                newBlockLocation,
//                Direction.south
//            );
////            pixelBlock = new PixelBlock(
////                newBlockLocation,
////                event.getPlayer().getUniqueId(),
////                UUID.randomUUID(),
////                direction
////            );
//        } else {
//            UUID itemUUID = info.id();
//            pixelBlock = PixelBlock.createPixelBlock(
//                UUID.randomUUID(),
//                even.getUniqueId(),
//                playerLocation.toBlockLocation(),
//                Direction.south
//            );
////            pixelBlock = Main.pixelBlocks.stream()
////                .filter(block -> block.getBlockUUID().equals(itemUUID))
////                .findFirst()
////                .orElseGet(() -> new PixelBlock(
////                    newBlockLocation,
////                    event.getPlayer().getUniqueId(),
////                    itemUUID,
////                    direction
////                ));
//        }
//
//        try {
//            pixelBlock.place(newBlockLocation, direction);
//        } catch (IllegalArgumentException e) {
//            event.setCancelled(true);
//            event.getPlayer().sendMessage(Component.text(e.getMessage()));
//        }
    }
}
