package eu.mhsl.minecraft.pixelblocks.utils;

import eu.mhsl.minecraft.pixelblocks.pixelblock.PixelBlock;
import eu.mhsl.minecraft.pixelblocks.pixelblock.PixelBlockWorld;
import org.bukkit.World;
import org.bukkit.event.Cancellable;

import java.util.Objects;
import java.util.function.Function;

public class EventCanceling {
    public static void shouldCancelInPixelBlock(Cancellable event, World world, Function<PixelBlock, Boolean> callback) {
        if(!PixelBlockWorld.isPixelWorld(world)) return;
        PixelBlock pixelBlock = PixelBlock.getPixelBlockFromBlockWorld(world);
        Objects.requireNonNull(pixelBlock);
        if(callback.apply(pixelBlock)) event.setCancelled(true);
    }

    public static void cancelIfInPixelWorld(Cancellable event, World world) {
        if(PixelBlockWorld.isPixelWorld(world)) {
            event.setCancelled(true);
        }
    }
}
